﻿using Styx;
using Styx.WoWInternals.WoWObjects;
using System.Threading.Tasks;
using Styx.CommonBot.Coroutines;
using Styx.Pathing;

namespace AreaHunter.Helpers
{
    partial class Composites
    {
        public static async Task<bool> LootRoutine()
        {
            WoWUnit unit = GetViableMob(GetLootableMob);
            if (!StyxWoW.Me.IsFlying && !StyxWoW.Me.IsActuallyInCombat && unit != null)
            {
                CustomLog.Diagnostic(unit.Name);
                if (StyxWoW.Me.CurrentTarget != unit)
                {
                    unit.Target();
                    return true;
                }
                else if (StyxWoW.Me.GotTarget && unit.InteractRange < unit.DistanceSqr && !StyxWoW.Me.IsMoving)
                {
                    Navigator.MoveTo(unit.Location);
                    //return true;
                }
                else if (StyxWoW.Me.GotTarget && unit.InteractRange > unit.DistanceSqr && !StyxWoW.Me.IsMoving)
                {

                    if (!unit.Looting)
                    {

                        unit.Interact();
                        await CommonCoroutines.SleepForRandomUiInteractionTime();
                        if (unit.Skinnable)
                        {
                            await CommonCoroutines.SleepForRandomUiInteractionTime();
                            await CommonCoroutines.SleepForRandomUiInteractionTime();
                        }
                        StyxWoW.Me.ClearTarget();
                        
                        return true;
                    }

                }

            }
            return false;
        }
        
        private static bool GetLootableMob(WoWUnit u)
        {
            return  u.InLineOfSight && u.IsValid && u.CanSelect && !u.IsAlive && (u.IsHostile || u.IsNeutral) && (u.Lootable || u.Skinnable);
        }

    }
}
